// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
//---------------------------------------------------------------------------
//
//                     XMM Science Analysis System (SAS)
//                    (c) 1997-2010 European Space Agency
//
//---------------------------------------------------------------------------
//
//	DssMisc.cc: --- implementation of miscellaneous DSS stuff
//
//	CHANGE HISTORY:
//		UL, 1999-11-16: 1.0.0: - first version
//
//	REFERENCES:
//		[1]: Documentation of selectlib package, U. Lammers
//
//	AUTHOR:
//		U. Lammers (UL), Tue Nov 16 09:56:55 MET 1999
//
//	$Header: /sasbuild/repositories/sasdev/sas/packages/dsslib/src/build/DssMisc.cc,v 1.1.1.1 2003/11/24 16:10:37 eojero Exp $
//

#include <cmath>

#include "Tracer.h"
#include "DssMisc.h"

namespace DssMisc {

//
//	PURPOSE:
//		Return fractional part of floating point number; disregard the
//		integer part
//
double modf(double d)
{
	PROC

	double idum;
	RETURN ::modf(d, &idum);
} // DssMisc::modf()


double intf(double d)
{
	PROC
	double idum;
	::modf(d, &idum);

	RETURN idum;
} // dssMisc::int()

};
