// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
/* A Bison parser, made by GNU Bison 2.3.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.3"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     PLUS = 258,
     MINUS = 259,
     MULT = 260,
     DIV = 261,
     EXPO = 262,
     MODULO = 263,
     ANDIF = 264,
     ORIF = 265,
     NOT = 266,
     BLOCKFILTER1 = 267,
     BLOCKFILTER2 = 268,
     IN = 269,
     RELOP = 270,
     AND = 271,
     OR = 272,
     XOR = 273,
     LSHIFT = 274,
     RSHIFT = 275,
     BITCOMPL = 276,
     TRUECONST = 277,
     FALSECONST = 278,
     RPOINT = 279,
     RLINE = 280,
     RCIRCLE = 281,
     RRING = 282,
     RELLIPSE = 283,
     RELLIPSERING = 284,
     RBOX = 285,
     RRECTANGLE = 286,
     RPOLYGON = 287,
     RSECTOR = 288,
     RDIAMOND = 289,
     BLOCK = 290,
     NUMBER = 291,
     AXISNAME = 292,
     AFUNC1 = 293,
     AFUNC2 = 294
   };
#endif
/* Tokens.  */
#define PLUS 258
#define MINUS 259
#define MULT 260
#define DIV 261
#define EXPO 262
#define MODULO 263
#define ANDIF 264
#define ORIF 265
#define NOT 266
#define BLOCKFILTER1 267
#define BLOCKFILTER2 268
#define IN 269
#define RELOP 270
#define AND 271
#define OR 272
#define XOR 273
#define LSHIFT 274
#define RSHIFT 275
#define BITCOMPL 276
#define TRUECONST 277
#define FALSECONST 278
#define RPOINT 279
#define RLINE 280
#define RCIRCLE 281
#define RRING 282
#define RELLIPSE 283
#define RELLIPSERING 284
#define RBOX 285
#define RRECTANGLE 286
#define RPOLYGON 287
#define RSECTOR 288
#define RDIAMOND 289
#define BLOCK 290
#define NUMBER 291
#define AXISNAME 292
#define AFUNC1 293
#define AFUNC2 294




/* Copy the first part of user declarations.  */
#line 1 "DssParser.y"

  //---------------------------------------------------------------------------
  //
  //                     XMM Science Analysis System (SAS)
  //                   (c) 1997-2010 European Space Agency
  //
  //---------------------------------------------------------------------------
  //
  //  DssGrammar.y --- grammar for DSS expressions
  //
  //  DESCRIPTION:
  //      This is a yacc/bison input file which defines the grammar of
  //      DSS-compliant selection expressions.
  //
  //  CHANGE HISTORY:
  //      UL, 1999-11-16: 1.0.0: - first version
  //      UL, 1999-12-17: 1.1.0: - brought in line with selectlib-4.23
  //                               (Region->GeoRegion)
  //
  //  AUTHOR:
  //      U. Lammers (UL), Tue Nov 16 10:35:01 MET 1999
  //
  //  $Header: /sasbuild/repositories/sasdev/sas/packages/dsslib/src/build/DssParser.cc,v 1.5 2013/11/12 16:12:11 aibarra Exp $
  ///

  //#include <values.h> // This may make Debian Linux happy
#include<cfloat>
#include <cmath>
#include <climits>
#include <string>
#include <cstdio>

#include "basicdefs.h"
#include "Dal.h"
#include "DssBuilder.h"

#define YYDEBUG 1

#define yylex       dsslex
  extern int dsslex();        //  this is the name of the lexer function
                              //  that flex generates with the -Pdss
                              //  option; we do need a distinct name
                              //  in order to avoid name clashes with
                              //  other lexers in the SAS

  namespace DssParser {

    extern void yyerror(char *);    //  The locally added functions in the
                                    //  lexer are in a namespace DssParser

    enum RelOp {LtOpT=1, LeOpT, GtOpT, GeOpT, EqOpT, NeOpT};
    
    extern const Table * yyFilteredTable;

    

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif

#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
#line 57 "DssParser.y"
{
    double                  yNumber;
    std::string                  *yBlockSpec;
    std::string                  *yAxisName;
    double                  (*yFunc1)(double);
    double                  (*yFunc2)(double, double);
    DRange                  *yRange;
    DRangeList              *yRangeList;
    std::vector<float>           *yPointList;
    RelOp                   yRelOp;
    DSfilter                *yDSfilter;
  }
/* Line 193 of yacc.c.  */
#line 243 "DssParser.cc"
	YYSTYPE;
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 216 of yacc.c.  */
#line 256 "DssParser.cc"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int i)
#else
static int
YYID (i)
    int i;
#endif
{
  return i;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  50
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1863

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  46
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  12
/* YYNRULES -- Number of rules.  */
#define YYNRULES  87
/* YYNRULES -- Number of states.  */
#define YYNSTATES  396

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   294

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      40,    41,     2,     2,    42,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    43,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    44,     2,    45,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     9,    12,    16,    20,    22,    24,
      28,    30,    34,    38,    45,    52,    63,    68,    77,    92,
     105,   109,   113,   115,   119,   123,   124,   132,   145,   160,
     177,   200,   217,   234,   251,   266,   275,   284,   295,   308,
     327,   340,   353,   366,   377,   382,   388,   392,   396,   398,
     402,   406,   410,   414,   418,   422,   426,   430,   434,   438,
     442,   445,   450,   457,   460,   464,   466,   468,   472,   476,
     480,   484,   486,   490,   493,   498,   503,   508,   513,   516,
     521,   526,   531,   536,   540,   546,   552,   558
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int8 yyrhs[] =
{
      47,     0,    -1,    48,    -1,    40,    48,    41,    -1,    11,
      48,    -1,    48,     9,    48,    -1,    48,    10,    48,    -1,
      50,    -1,    37,    -1,    40,    37,    41,    -1,    22,    -1,
      49,    14,    55,    -1,    51,    15,    36,    -1,    49,    14,
      12,    40,    35,    41,    -1,    12,    40,    35,    42,    49,
      41,    -1,    40,    49,    42,    49,    41,    14,    13,    40,
      35,    41,    -1,    13,    40,    35,    41,    -1,    13,    40,
      35,    42,    49,    42,    49,    41,    -1,    40,    49,    42,
      49,    41,    14,    13,    40,    35,    42,    56,    42,    56,
      41,    -1,    13,    40,    35,    42,    56,    42,    56,    42,
      49,    42,    49,    41,    -1,    49,    15,    56,    -1,    56,
      15,    49,    -1,    52,    -1,    49,    16,    56,    -1,    40,
      51,    41,    -1,    -1,    40,    49,    42,    49,    41,    14,
      53,    -1,    26,    40,    56,    42,    56,    42,    56,    42,
      49,    42,    49,    41,    -1,    27,    40,    56,    42,    56,
      42,    56,    42,    56,    42,    49,    42,    49,    41,    -1,
      28,    40,    56,    42,    56,    42,    56,    42,    56,    42,
      56,    42,    49,    42,    49,    41,    -1,    29,    40,    56,
      42,    56,    42,    56,    42,    56,    42,    56,    42,    56,
      42,    56,    42,    56,    42,    49,    42,    49,    41,    -1,
      30,    40,    56,    42,    56,    42,    56,    42,    56,    42,
      56,    42,    49,    42,    49,    41,    -1,    31,    40,    56,
      42,    56,    42,    56,    42,    56,    42,    56,    42,    49,
      42,    49,    41,    -1,    34,    40,    56,    42,    56,    42,
      56,    42,    56,    42,    56,    42,    49,    42,    49,    41,
      -1,    33,    40,    56,    42,    56,    42,    56,    42,    56,
      42,    49,    42,    49,    41,    -1,    32,    40,    54,    42,
      49,    42,    49,    41,    -1,    26,    40,    56,    42,    56,
      42,    56,    41,    -1,    27,    40,    56,    42,    56,    42,
      56,    42,    56,    41,    -1,    28,    40,    56,    42,    56,
      42,    56,    42,    56,    42,    56,    41,    -1,    29,    40,
      56,    42,    56,    42,    56,    42,    56,    42,    56,    42,
      56,    42,    56,    42,    56,    41,    -1,    30,    40,    56,
      42,    56,    42,    56,    42,    56,    42,    56,    41,    -1,
      31,    40,    56,    42,    56,    42,    56,    42,    56,    42,
      56,    41,    -1,    34,    40,    56,    42,    56,    42,    56,
      42,    56,    42,    56,    41,    -1,    33,    40,    56,    42,
      56,    42,    56,    42,    56,    41,    -1,    32,    40,    54,
      41,    -1,    54,    42,    56,    42,    56,    -1,    56,    42,
      56,    -1,    55,    42,    57,    -1,    57,    -1,    56,     3,
      56,    -1,    56,     4,    56,    -1,    56,     5,    56,    -1,
      56,     6,    56,    -1,    56,     8,    56,    -1,    56,     7,
      56,    -1,    56,    16,    56,    -1,    56,    17,    56,    -1,
      56,    18,    56,    -1,    56,    19,    56,    -1,    56,    20,
      56,    -1,    21,    56,    -1,    38,    40,    56,    41,    -1,
      39,    40,    56,    42,    56,    41,    -1,     4,    56,    -1,
      40,    56,    41,    -1,    36,    -1,    43,    -1,    44,    43,
      45,    -1,    40,    43,    45,    -1,    44,    43,    41,    -1,
      40,    43,    41,    -1,    56,    -1,    44,    56,    45,    -1,
      56,    43,    -1,    44,    56,    43,    45,    -1,    44,    56,
      43,    41,    -1,    40,    56,    43,    45,    -1,    40,    56,
      43,    41,    -1,    43,    56,    -1,    44,    43,    56,    45,
      -1,    44,    43,    56,    41,    -1,    40,    43,    56,    45,
      -1,    40,    43,    56,    41,    -1,    56,    43,    56,    -1,
      44,    56,    43,    56,    45,    -1,    40,    56,    43,    56,
      45,    -1,    44,    56,    43,    56,    41,    -1,    40,    56,
      43,    56,    41,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   104,   104,   107,   108,   109,   110,   111,   114,   115,
     118,   119,   131,   140,   152,   164,   173,   178,   187,   201,
     215,   257,   298,   310,   327,   331,   331,   334,   339,   344,
     349,   354,   359,   364,   369,   374,   382,   385,   388,   391,
     394,   397,   400,   403,   406,   412,   417,   425,   430,   436,
     437,   438,   439,   446,   453,   461,   462,   463,   464,   465,
     466,   467,   468,   470,   471,   472,   475,   477,   479,   481,
     483,   485,   486,   487,   489,   491,   493,   495,   497,   499,
     501,   503,   505,   507,   508,   509,   511,   513
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "PLUS", "MINUS", "MULT", "DIV", "EXPO",
  "MODULO", "ANDIF", "ORIF", "NOT", "BLOCKFILTER1", "BLOCKFILTER2", "IN",
  "RELOP", "AND", "OR", "XOR", "LSHIFT", "RSHIFT", "BITCOMPL", "TRUECONST",
  "FALSECONST", "RPOINT", "RLINE", "RCIRCLE", "RRING", "RELLIPSE",
  "RELLIPSERING", "RBOX", "RRECTANGLE", "RPOLYGON", "RSECTOR", "RDIAMOND",
  "BLOCK", "NUMBER", "AXISNAME", "AFUNC1", "AFUNC2", "'('", "')'", "','",
  "':'", "'['", "']'", "$accept", "dssexpr", "dss", "axisname", "filter",
  "bitmask", "regionfilter", "regiontype", "pointlist", "intervallist",
  "arith", "intervalspec", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
      40,    41,    44,    58,    91,    93
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    46,    47,    48,    48,    48,    48,    48,    49,    49,
      50,    50,    50,    50,    50,    50,    50,    50,    50,    50,
      50,    50,    50,    51,    51,    52,    52,    52,    52,    52,
      52,    52,    52,    52,    52,    52,    53,    53,    53,    53,
      53,    53,    53,    53,    53,    54,    54,    55,    55,    56,
      56,    56,    56,    56,    56,    56,    56,    56,    56,    56,
      56,    56,    56,    56,    56,    56,    57,    57,    57,    57,
      57,    57,    57,    57,    57,    57,    57,    57,    57,    57,
      57,    57,    57,    57,    57,    57,    57,    57
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     3,     2,     3,     3,     1,     1,     3,
       1,     3,     3,     6,     6,    10,     4,     8,    14,    12,
       3,     3,     1,     3,     3,     0,     7,    12,    14,    16,
      22,    16,    16,    16,    14,     8,     8,    10,    12,    18,
      12,    12,    12,    10,     4,     5,     3,     3,     1,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       2,     4,     6,     2,     3,     1,     1,     3,     3,     3,
       3,     1,     3,     2,     4,     4,     4,     4,     2,     4,
       4,     4,     4,     3,     5,     5,     5,     5
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
      25,     0,    25,     0,     0,     0,    10,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    65,     8,     0,     0,
      25,     0,     2,     0,     7,     0,    22,     0,     0,    63,
       4,     0,     0,    60,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     8,     0,     0,     0,     0,
       1,    25,    25,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     9,     3,     0,    24,    64,     5,
       6,     0,     0,    66,     0,    11,    71,    48,    20,    23,
      12,    49,    50,    51,    52,    54,    53,     0,    21,    55,
      56,    57,    58,    59,     0,    16,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    61,     0,     0,
       0,     0,     0,    78,     0,     0,     0,    73,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    46,     0,     0,     0,     0,     0,    70,    68,     0,
       0,    69,    67,     0,     0,    72,    47,    83,    14,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    62,     0,    13,    82,    81,    77,    76,     0,    80,
      79,    75,    74,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    45,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    26,    87,    85,    86,
      84,    17,     0,     0,     0,     0,     0,     0,     0,    35,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      15,     0,     0,     0,     0,     0,     0,     0,    44,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      19,    27,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    28,     0,     0,     0,     0,    34,
       0,    18,    36,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    29,     0,    31,    32,    33,    37,     0,     0,
       0,     0,    43,     0,     0,     0,     0,     0,     0,     0,
       0,    38,     0,    40,    41,    42,     0,     0,     0,     0,
       0,     0,    30,     0,     0,    39
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    21,    22,    23,    24,    25,    26,   216,    78,    95,
      27,    97
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -40
static const yytype_int16 yypact[] =
{
    1739,  1790,  1739,   -39,   -15,  1790,   -40,    -8,    38,    43,
      44,    54,    55,    61,    67,    68,   -40,   -40,    70,    71,
    1770,    96,    -4,    15,   -40,    40,   -40,   183,  1790,   -40,
     -40,    78,    79,   -40,  1790,  1790,  1790,  1790,  1790,  1790,
    1790,  1790,  1790,  1790,  1790,    85,     7,    56,   -13,  1565,
     -40,  1739,  1739,   454,  1790,  1790,    92,  1790,  1790,  1790,
    1790,  1790,  1790,   -22,  1790,  1790,  1790,  1790,  1790,  1571,
      89,   -28,   496,   502,   523,   529,   550,   556,    90,   577,
     583,   604,  1591,   610,   -40,   -40,   -22,   -40,   -40,   -40,
     125,    97,  1518,  1790,  1524,    98,   445,   -40,  1837,  1837,
     -40,    82,    82,   131,   131,   -40,   131,   104,   -40,   476,
    1528,  1843,   204,   204,   -22,   -40,   372,  1790,  1790,  1790,
    1790,  1790,  1790,   372,  1790,  1790,  1790,   -40,  1790,   101,
     110,    41,   427,  1837,    64,     4,   433,  1790,    85,   102,
    1784,   109,   631,   637,   658,   664,   685,   691,   712,   112,
     718,  1837,   739,   745,  1597,   136,   114,   -40,   -40,   177,
     108,   -40,   -40,   333,   256,   -40,   -40,  1837,   -40,   -22,
    1790,  1790,  1790,  1790,  1790,  1790,  1790,   -22,  1790,  1790,
    1790,   -40,  1805,   -40,   -40,   -40,   -40,   -40,   379,   -40,
     -40,   -40,   -40,   397,   115,   766,   772,   793,   799,   820,
     826,   847,   116,  1837,   853,   874,   118,   121,   122,   124,
     126,   127,   128,   152,   164,   173,   -40,   -40,   -40,   -40,
     -40,   -40,   -22,   -22,  1790,  1790,  1790,  1790,  1790,   -40,
    1790,  1790,   130,  1790,  1790,  1790,  1790,  1790,  1790,  1790,
    1790,  1790,   134,   172,   880,   901,   907,   928,   934,   955,
     961,     9,   982,   988,  1009,  1015,  1036,  1042,    32,  1063,
    1069,   -22,   -22,   -22,  1790,  1790,  1790,  1790,   -22,  1790,
     -40,  1790,  1790,  1790,  1790,  1790,  1790,  1790,   -40,  1790,
    1790,  1790,   174,   175,   178,  1090,  1096,  1117,  1123,   179,
    1144,  1150,  1171,  1177,  1198,  1204,  1225,  1231,  1252,  1258,
     -40,   -40,   -22,   -22,  1790,   -22,   -22,   -22,   -22,  1790,
    1790,  1790,  1790,  1790,  1790,  1790,  1790,  1790,   176,   186,
    1279,   189,   199,   201,   205,  1617,  1623,  1285,  1306,  1312,
    1333,  1339,  1360,  1366,   -40,   -22,  1790,   -22,   -22,   -40,
     -22,   -40,   -40,  1790,  1790,  1790,  1790,  1790,  1790,  1790,
     202,  1387,   207,   208,   209,  1643,  1393,  1414,  1420,  1441,
    1649,  1447,   -40,  1790,   -40,   -40,   -40,   -40,  1790,  1790,
    1790,  1790,   -40,  1790,  1468,  1669,  1474,  1675,  1695,  1701,
     -22,   -40,  1790,   -40,   -40,   -40,   210,  1495,   -22,  1790,
     212,  1501,   -40,  1790,  1721,   -40
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
     -40,   -40,    24,   -17,   -40,   234,   -40,   -40,   -20,   -40,
      -1,   119
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const yytype_uint16 yytable[] =
{
      29,    31,    56,    47,    33,    51,    52,    57,    58,    59,
      60,    61,    62,   115,   116,    17,    51,    52,   107,    49,
      64,    65,    66,    67,    68,    32,    30,    69,    87,    53,
      54,    55,    34,    72,    73,    74,    75,    76,    77,    79,
      80,    81,    82,    83,    46,     1,   108,   164,    85,   165,
     270,   271,    96,    98,    99,    56,   101,   102,   103,   104,
     105,   106,     5,   109,   110,   111,   112,   113,     1,   129,
      53,    54,    55,   278,   279,    89,    90,    16,    35,    18,
      19,    28,   157,    36,    37,     5,   158,    59,    60,    61,
      62,   132,   133,   135,    38,    39,    50,   139,    86,   141,
      16,    40,    18,    19,    28,   161,   149,    41,    42,   162,
      43,    44,     1,    70,    71,   142,   143,   144,   145,   146,
     147,   148,   150,   151,   152,   153,    84,   154,   100,     5,
     159,   114,   123,   163,    51,    96,   167,   130,    61,    69,
     136,   138,   155,   168,    16,   156,    18,    19,    28,   186,
     182,   169,   194,   187,   177,   183,   221,   229,   232,   188,
     202,   233,   234,   193,   235,   251,   236,   237,   238,   195,
     196,   197,   198,   199,   200,   201,   261,   203,   204,   205,
      57,    58,    59,    60,    61,    62,    57,    58,    59,    60,
      61,    62,   239,    64,    65,    66,    67,    68,    63,    64,
      65,    66,    67,    68,   240,   242,   243,    57,    58,    59,
      60,    61,    62,   241,   262,   300,   301,   334,   184,   258,
     302,   307,   185,   244,   245,   246,   247,   248,   335,   249,
     250,   337,   252,   253,   254,   255,   256,   257,    79,   259,
     260,   338,   339,   362,   282,   283,   284,   340,   364,   365,
     366,   289,   388,   392,    48,   166,     0,     0,     0,     0,
       1,     0,     0,   285,   286,   287,   288,     0,   290,     0,
     291,   292,   293,   294,   295,   296,   297,     5,   150,   298,
     299,     0,     0,     0,     0,   318,   319,     0,   321,   322,
     323,   324,    16,     0,    18,    19,    28,   191,     0,     0,
       0,   192,     0,   320,     0,     0,     0,     0,   325,   326,
     327,   328,   329,   330,   331,   332,   333,     0,   350,     0,
     352,   353,     0,   354,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   351,    57,    58,    59,    60,
      61,    62,   355,   356,   357,   358,   359,   360,   361,    64,
      65,    66,    67,    68,     0,     0,     0,     0,     0,     0,
       0,     0,   374,   386,     0,     0,     0,   375,   376,   377,
     378,   390,   379,     0,   189,     0,     1,     0,   190,     0,
       0,   387,    57,    58,    59,    60,    61,    62,   391,     0,
       0,     0,   394,     5,     0,    64,    65,    66,    67,    68,
      57,    58,    59,    60,    61,    62,     0,     0,    16,    17,
      18,    19,   140,    64,    65,    66,    67,    68,     0,     0,
     217,     0,     0,     0,   218,     0,     0,     0,     0,     0,
      57,    58,    59,    60,    61,    62,     0,     1,   219,     0,
       0,     0,   220,    64,    65,    66,    67,    68,    57,    58,
      59,    60,    61,    62,     5,     0,     0,     0,     1,     0,
       0,    64,    65,    66,    67,    68,    91,     0,    88,    16,
     160,    18,    19,    92,     0,     5,    93,    94,     0,    57,
      58,    59,    60,    61,    62,     0,     0,     0,   137,     0,
      16,     0,    18,    19,    92,    67,    68,    93,    94,    57,
      58,    59,    60,    61,    62,    57,    58,    59,    60,    61,
      62,     0,    64,    65,    66,    67,    68,     0,    64,    65,
      66,    67,    68,     0,     0,     0,    57,    58,    59,    60,
      61,    62,    57,    58,    59,    60,    61,    62,   117,    64,
      65,    66,    67,    68,   118,    64,    65,    66,    67,    68,
       0,     0,     0,    57,    58,    59,    60,    61,    62,    57,
      58,    59,    60,    61,    62,   119,    64,    65,    66,    67,
      68,   120,    64,    65,    66,    67,    68,     0,     0,     0,
      57,    58,    59,    60,    61,    62,    57,    58,    59,    60,
      61,    62,   121,    64,    65,    66,    67,    68,   122,    64,
      65,    66,    67,    68,     0,     0,     0,    57,    58,    59,
      60,    61,    62,    57,    58,    59,    60,    61,    62,   124,
      64,    65,    66,    67,    68,   125,    64,    65,    66,    67,
      68,     0,     0,     0,    57,    58,    59,    60,    61,    62,
      57,    58,    59,    60,    61,    62,   126,    64,    65,    66,
      67,    68,   128,    64,    65,    66,    67,    68,     0,     0,
       0,    57,    58,    59,    60,    61,    62,    57,    58,    59,
      60,    61,    62,   170,    64,    65,    66,    67,    68,   171,
      64,    65,    66,    67,    68,     0,     0,     0,    57,    58,
      59,    60,    61,    62,    57,    58,    59,    60,    61,    62,
     172,    64,    65,    66,    67,    68,   173,    64,    65,    66,
      67,    68,     0,     0,     0,    57,    58,    59,    60,    61,
      62,    57,    58,    59,    60,    61,    62,   174,    64,    65,
      66,    67,    68,   175,    64,    65,    66,    67,    68,     0,
       0,     0,    57,    58,    59,    60,    61,    62,    57,    58,
      59,    60,    61,    62,   176,    64,    65,    66,    67,    68,
     178,    64,    65,    66,    67,    68,     0,     0,     0,    57,
      58,    59,    60,    61,    62,    57,    58,    59,    60,    61,
      62,   179,    64,    65,    66,    67,    68,   180,    64,    65,
      66,    67,    68,     0,     0,     0,    57,    58,    59,    60,
      61,    62,    57,    58,    59,    60,    61,    62,   222,    64,
      65,    66,    67,    68,   223,    64,    65,    66,    67,    68,
       0,     0,     0,    57,    58,    59,    60,    61,    62,    57,
      58,    59,    60,    61,    62,   224,    64,    65,    66,    67,
      68,   225,    64,    65,    66,    67,    68,     0,     0,     0,
      57,    58,    59,    60,    61,    62,    57,    58,    59,    60,
      61,    62,   226,    64,    65,    66,    67,    68,   227,    64,
      65,    66,    67,    68,     0,     0,     0,    57,    58,    59,
      60,    61,    62,    57,    58,    59,    60,    61,    62,   228,
      64,    65,    66,    67,    68,   230,    64,    65,    66,    67,
      68,     0,     0,     0,    57,    58,    59,    60,    61,    62,
      57,    58,    59,    60,    61,    62,   231,    64,    65,    66,
      67,    68,   263,    64,    65,    66,    67,    68,     0,     0,
       0,    57,    58,    59,    60,    61,    62,    57,    58,    59,
      60,    61,    62,   264,    64,    65,    66,    67,    68,   265,
      64,    65,    66,    67,    68,     0,     0,     0,    57,    58,
      59,    60,    61,    62,    57,    58,    59,    60,    61,    62,
     266,    64,    65,    66,    67,    68,   267,    64,    65,    66,
      67,    68,     0,     0,     0,    57,    58,    59,    60,    61,
      62,    57,    58,    59,    60,    61,    62,   268,    64,    65,
      66,    67,    68,   269,    64,    65,    66,    67,    68,     0,
       0,     0,    57,    58,    59,    60,    61,    62,    57,    58,
      59,    60,    61,    62,   272,    64,    65,    66,    67,    68,
     273,    64,    65,    66,    67,    68,     0,     0,     0,    57,
      58,    59,    60,    61,    62,    57,    58,    59,    60,    61,
      62,   274,    64,    65,    66,    67,    68,   275,    64,    65,
      66,    67,    68,     0,     0,     0,    57,    58,    59,    60,
      61,    62,    57,    58,    59,    60,    61,    62,   276,    64,
      65,    66,    67,    68,   277,    64,    65,    66,    67,    68,
       0,     0,     0,    57,    58,    59,    60,    61,    62,    57,
      58,    59,    60,    61,    62,   280,    64,    65,    66,    67,
      68,   281,    64,    65,    66,    67,    68,     0,     0,     0,
      57,    58,    59,    60,    61,    62,    57,    58,    59,    60,
      61,    62,   303,    64,    65,    66,    67,    68,   304,    64,
      65,    66,    67,    68,     0,     0,     0,    57,    58,    59,
      60,    61,    62,    57,    58,    59,    60,    61,    62,   305,
      64,    65,    66,    67,    68,   306,    64,    65,    66,    67,
      68,     0,     0,     0,    57,    58,    59,    60,    61,    62,
      57,    58,    59,    60,    61,    62,   308,    64,    65,    66,
      67,    68,   309,    64,    65,    66,    67,    68,     0,     0,
       0,    57,    58,    59,    60,    61,    62,    57,    58,    59,
      60,    61,    62,   310,    64,    65,    66,    67,    68,   311,
      64,    65,    66,    67,    68,     0,     0,     0,    57,    58,
      59,    60,    61,    62,    57,    58,    59,    60,    61,    62,
     312,    64,    65,    66,    67,    68,   313,    64,    65,    66,
      67,    68,     0,     0,     0,    57,    58,    59,    60,    61,
      62,    57,    58,    59,    60,    61,    62,   314,    64,    65,
      66,    67,    68,   315,    64,    65,    66,    67,    68,     0,
       0,     0,    57,    58,    59,    60,    61,    62,    57,    58,
      59,    60,    61,    62,   316,    64,    65,    66,    67,    68,
     317,    64,    65,    66,    67,    68,     0,     0,     0,    57,
      58,    59,    60,    61,    62,    57,    58,    59,    60,    61,
      62,   336,    64,    65,    66,    67,    68,   343,    64,    65,
      66,    67,    68,     0,     0,     0,    57,    58,    59,    60,
      61,    62,    57,    58,    59,    60,    61,    62,   344,    64,
      65,    66,    67,    68,   345,    64,    65,    66,    67,    68,
       0,     0,     0,    57,    58,    59,    60,    61,    62,    57,
      58,    59,    60,    61,    62,   346,    64,    65,    66,    67,
      68,   347,    64,    65,    66,    67,    68,     0,     0,     0,
      57,    58,    59,    60,    61,    62,    57,    58,    59,    60,
      61,    62,   348,    64,    65,    66,    67,    68,   349,    64,
      65,    66,    67,    68,     0,     0,     0,    57,    58,    59,
      60,    61,    62,    57,    58,    59,    60,    61,    62,   363,
      64,    65,    66,    67,    68,   368,    64,    65,    66,    67,
      68,     0,     0,     0,    57,    58,    59,    60,    61,    62,
      57,    58,    59,    60,    61,    62,   369,    64,    65,    66,
      67,    68,   370,    64,    65,    66,    67,    68,     0,     0,
       0,    57,    58,    59,    60,    61,    62,    57,    58,    59,
      60,    61,    62,   371,    64,    65,    66,    67,    68,   373,
      64,    65,    66,    67,    68,     0,     0,     0,    57,    58,
      59,    60,    61,    62,    57,    58,    59,    60,    61,    62,
     380,    64,    65,    66,    67,    68,   382,    64,    65,    66,
      67,    68,     1,     0,     0,     0,     0,     0,     1,     0,
       0,    57,    58,    59,    60,    61,    62,   389,     0,     5,
       0,     0,     0,   393,    64,     5,    66,    67,    68,     0,
       0,     0,     0,     0,    16,     0,    18,    19,    28,     0,
      16,   131,    18,    19,    28,     0,     0,   134,    57,    58,
      59,    60,    61,    62,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,     0,    64,    65,    66,
      67,    68,     0,     0,    57,    58,    59,    60,    61,    62,
      57,    58,    59,    60,    61,    62,    88,    64,    65,    66,
      67,    68,    88,    64,    65,    66,    67,    68,     0,     0,
      57,    58,    59,    60,    61,    62,    57,    58,    59,    60,
      61,    62,   127,    64,    65,    66,    67,    68,   181,    64,
      65,    66,    67,    68,     0,     0,    57,    58,    59,    60,
      61,    62,    57,    58,    59,    60,    61,    62,   341,    64,
      65,    66,    67,    68,   342,    64,    65,    66,    67,    68,
       0,     0,    57,    58,    59,    60,    61,    62,    57,    58,
      59,    60,    61,    62,   367,    64,    65,    66,    67,    68,
     372,    64,    65,    66,    67,    68,     0,     0,    57,    58,
      59,    60,    61,    62,    57,    58,    59,    60,    61,    62,
     381,    64,    65,    66,    67,    68,   383,    64,    65,    66,
      67,    68,     0,     0,    57,    58,    59,    60,    61,    62,
       0,     0,     0,     0,     0,     0,   384,    64,    65,    66,
      67,    68,   385,     1,     0,     0,     0,     0,     0,     0,
       2,     3,     4,     0,     0,     0,     0,     0,     0,     0,
       5,     6,   395,     0,     0,     7,     8,     9,    10,    11,
      12,    13,    14,    15,     1,    16,    17,    18,    19,    20,
       0,     2,     3,     4,     0,     0,     0,     0,     1,     0,
       0,     5,     6,     0,     1,     0,     7,     8,     9,    10,
      11,    12,    13,    14,    15,     5,    16,    45,    18,    19,
      20,     5,     0,     0,     0,     0,     0,     0,   206,     0,
      16,   138,    18,    19,    28,     0,    16,     0,    18,    19,
      28,   207,   208,   209,   210,   211,   212,   213,   214,   215,
      57,    58,    59,    60,    61,    62,    57,    58,    59,    60,
      61,    62,     0,    64,    65,    66,    67,    68,     0,    64,
       0,     0,    67,    68
};

static const yytype_int16 yycheck[] =
{
       1,    40,    15,    20,     5,     9,    10,     3,     4,     5,
       6,     7,     8,    41,    42,    37,     9,    10,    40,    20,
      16,    17,    18,    19,    20,    40,     2,    28,    41,    14,
      15,    16,    40,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    20,     4,    63,    43,    41,    45,
      41,    42,    53,    54,    55,    15,    57,    58,    59,    60,
      61,    62,    21,    64,    65,    66,    67,    68,     4,    86,
      14,    15,    16,    41,    42,    51,    52,    36,    40,    38,
      39,    40,    41,    40,    40,    21,    45,     5,     6,     7,
       8,    92,    93,    94,    40,    40,     0,   114,    42,   116,
      36,    40,    38,    39,    40,    41,   123,    40,    40,    45,
      40,    40,     4,    35,    35,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,    41,   128,    36,    21,
     131,    42,    42,   134,     9,   136,   137,    40,     7,   140,
      42,    37,    41,    41,    36,    35,    38,    39,    40,    41,
      14,    42,   169,    45,    42,    41,    41,    41,    40,   160,
     177,    40,    40,   164,    40,    35,    40,    40,    40,   170,
     171,   172,   173,   174,   175,   176,    42,   178,   179,   180,
       3,     4,     5,     6,     7,     8,     3,     4,     5,     6,
       7,     8,    40,    16,    17,    18,    19,    20,    15,    16,
      17,    18,    19,    20,    40,   222,   223,     3,     4,     5,
       6,     7,     8,    40,    42,    41,    41,    41,    41,   239,
      42,    42,    45,   224,   225,   226,   227,   228,    42,   230,
     231,    42,   233,   234,   235,   236,   237,   238,   239,   240,
     241,    42,    41,    41,   261,   262,   263,    42,    41,    41,
      41,   268,    42,    41,    20,   136,    -1,    -1,    -1,    -1,
       4,    -1,    -1,   264,   265,   266,   267,    -1,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    21,   279,   280,
     281,    -1,    -1,    -1,    -1,   302,   303,    -1,   305,   306,
     307,   308,    36,    -1,    38,    39,    40,    41,    -1,    -1,
      -1,    45,    -1,   304,    -1,    -1,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,   317,    -1,   335,    -1,
     337,   338,    -1,   340,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   336,     3,     4,     5,     6,
       7,     8,   343,   344,   345,   346,   347,   348,   349,    16,
      17,    18,    19,    20,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   363,   380,    -1,    -1,    -1,   368,   369,   370,
     371,   388,   373,    -1,    41,    -1,     4,    -1,    45,    -1,
      -1,   382,     3,     4,     5,     6,     7,     8,   389,    -1,
      -1,    -1,   393,    21,    -1,    16,    17,    18,    19,    20,
       3,     4,     5,     6,     7,     8,    -1,    -1,    36,    37,
      38,    39,    40,    16,    17,    18,    19,    20,    -1,    -1,
      41,    -1,    -1,    -1,    45,    -1,    -1,    -1,    -1,    -1,
       3,     4,     5,     6,     7,     8,    -1,     4,    41,    -1,
      -1,    -1,    45,    16,    17,    18,    19,    20,     3,     4,
       5,     6,     7,     8,    21,    -1,    -1,    -1,     4,    -1,
      -1,    16,    17,    18,    19,    20,    12,    -1,    41,    36,
      43,    38,    39,    40,    -1,    21,    43,    44,    -1,     3,
       4,     5,     6,     7,     8,    -1,    -1,    -1,    43,    -1,
      36,    -1,    38,    39,    40,    19,    20,    43,    44,     3,
       4,     5,     6,     7,     8,     3,     4,     5,     6,     7,
       8,    -1,    16,    17,    18,    19,    20,    -1,    16,    17,
      18,    19,    20,    -1,    -1,    -1,     3,     4,     5,     6,
       7,     8,     3,     4,     5,     6,     7,     8,    42,    16,
      17,    18,    19,    20,    42,    16,    17,    18,    19,    20,
      -1,    -1,    -1,     3,     4,     5,     6,     7,     8,     3,
       4,     5,     6,     7,     8,    42,    16,    17,    18,    19,
      20,    42,    16,    17,    18,    19,    20,    -1,    -1,    -1,
       3,     4,     5,     6,     7,     8,     3,     4,     5,     6,
       7,     8,    42,    16,    17,    18,    19,    20,    42,    16,
      17,    18,    19,    20,    -1,    -1,    -1,     3,     4,     5,
       6,     7,     8,     3,     4,     5,     6,     7,     8,    42,
      16,    17,    18,    19,    20,    42,    16,    17,    18,    19,
      20,    -1,    -1,    -1,     3,     4,     5,     6,     7,     8,
       3,     4,     5,     6,     7,     8,    42,    16,    17,    18,
      19,    20,    42,    16,    17,    18,    19,    20,    -1,    -1,
      -1,     3,     4,     5,     6,     7,     8,     3,     4,     5,
       6,     7,     8,    42,    16,    17,    18,    19,    20,    42,
      16,    17,    18,    19,    20,    -1,    -1,    -1,     3,     4,
       5,     6,     7,     8,     3,     4,     5,     6,     7,     8,
      42,    16,    17,    18,    19,    20,    42,    16,    17,    18,
      19,    20,    -1,    -1,    -1,     3,     4,     5,     6,     7,
       8,     3,     4,     5,     6,     7,     8,    42,    16,    17,
      18,    19,    20,    42,    16,    17,    18,    19,    20,    -1,
      -1,    -1,     3,     4,     5,     6,     7,     8,     3,     4,
       5,     6,     7,     8,    42,    16,    17,    18,    19,    20,
      42,    16,    17,    18,    19,    20,    -1,    -1,    -1,     3,
       4,     5,     6,     7,     8,     3,     4,     5,     6,     7,
       8,    42,    16,    17,    18,    19,    20,    42,    16,    17,
      18,    19,    20,    -1,    -1,    -1,     3,     4,     5,     6,
       7,     8,     3,     4,     5,     6,     7,     8,    42,    16,
      17,    18,    19,    20,    42,    16,    17,    18,    19,    20,
      -1,    -1,    -1,     3,     4,     5,     6,     7,     8,     3,
       4,     5,     6,     7,     8,    42,    16,    17,    18,    19,
      20,    42,    16,    17,    18,    19,    20,    -1,    -1,    -1,
       3,     4,     5,     6,     7,     8,     3,     4,     5,     6,
       7,     8,    42,    16,    17,    18,    19,    20,    42,    16,
      17,    18,    19,    20,    -1,    -1,    -1,     3,     4,     5,
       6,     7,     8,     3,     4,     5,     6,     7,     8,    42,
      16,    17,    18,    19,    20,    42,    16,    17,    18,    19,
      20,    -1,    -1,    -1,     3,     4,     5,     6,     7,     8,
       3,     4,     5,     6,     7,     8,    42,    16,    17,    18,
      19,    20,    42,    16,    17,    18,    19,    20,    -1,    -1,
      -1,     3,     4,     5,     6,     7,     8,     3,     4,     5,
       6,     7,     8,    42,    16,    17,    18,    19,    20,    42,
      16,    17,    18,    19,    20,    -1,    -1,    -1,     3,     4,
       5,     6,     7,     8,     3,     4,     5,     6,     7,     8,
      42,    16,    17,    18,    19,    20,    42,    16,    17,    18,
      19,    20,    -1,    -1,    -1,     3,     4,     5,     6,     7,
       8,     3,     4,     5,     6,     7,     8,    42,    16,    17,
      18,    19,    20,    42,    16,    17,    18,    19,    20,    -1,
      -1,    -1,     3,     4,     5,     6,     7,     8,     3,     4,
       5,     6,     7,     8,    42,    16,    17,    18,    19,    20,
      42,    16,    17,    18,    19,    20,    -1,    -1,    -1,     3,
       4,     5,     6,     7,     8,     3,     4,     5,     6,     7,
       8,    42,    16,    17,    18,    19,    20,    42,    16,    17,
      18,    19,    20,    -1,    -1,    -1,     3,     4,     5,     6,
       7,     8,     3,     4,     5,     6,     7,     8,    42,    16,
      17,    18,    19,    20,    42,    16,    17,    18,    19,    20,
      -1,    -1,    -1,     3,     4,     5,     6,     7,     8,     3,
       4,     5,     6,     7,     8,    42,    16,    17,    18,    19,
      20,    42,    16,    17,    18,    19,    20,    -1,    -1,    -1,
       3,     4,     5,     6,     7,     8,     3,     4,     5,     6,
       7,     8,    42,    16,    17,    18,    19,    20,    42,    16,
      17,    18,    19,    20,    -1,    -1,    -1,     3,     4,     5,
       6,     7,     8,     3,     4,     5,     6,     7,     8,    42,
      16,    17,    18,    19,    20,    42,    16,    17,    18,    19,
      20,    -1,    -1,    -1,     3,     4,     5,     6,     7,     8,
       3,     4,     5,     6,     7,     8,    42,    16,    17,    18,
      19,    20,    42,    16,    17,    18,    19,    20,    -1,    -1,
      -1,     3,     4,     5,     6,     7,     8,     3,     4,     5,
       6,     7,     8,    42,    16,    17,    18,    19,    20,    42,
      16,    17,    18,    19,    20,    -1,    -1,    -1,     3,     4,
       5,     6,     7,     8,     3,     4,     5,     6,     7,     8,
      42,    16,    17,    18,    19,    20,    42,    16,    17,    18,
      19,    20,    -1,    -1,    -1,     3,     4,     5,     6,     7,
       8,     3,     4,     5,     6,     7,     8,    42,    16,    17,
      18,    19,    20,    42,    16,    17,    18,    19,    20,    -1,
      -1,    -1,     3,     4,     5,     6,     7,     8,     3,     4,
       5,     6,     7,     8,    42,    16,    17,    18,    19,    20,
      42,    16,    17,    18,    19,    20,    -1,    -1,    -1,     3,
       4,     5,     6,     7,     8,     3,     4,     5,     6,     7,
       8,    42,    16,    17,    18,    19,    20,    42,    16,    17,
      18,    19,    20,    -1,    -1,    -1,     3,     4,     5,     6,
       7,     8,     3,     4,     5,     6,     7,     8,    42,    16,
      17,    18,    19,    20,    42,    16,    17,    18,    19,    20,
      -1,    -1,    -1,     3,     4,     5,     6,     7,     8,     3,
       4,     5,     6,     7,     8,    42,    16,    17,    18,    19,
      20,    42,    16,    17,    18,    19,    20,    -1,    -1,    -1,
       3,     4,     5,     6,     7,     8,     3,     4,     5,     6,
       7,     8,    42,    16,    17,    18,    19,    20,    42,    16,
      17,    18,    19,    20,    -1,    -1,    -1,     3,     4,     5,
       6,     7,     8,     3,     4,     5,     6,     7,     8,    42,
      16,    17,    18,    19,    20,    42,    16,    17,    18,    19,
      20,    -1,    -1,    -1,     3,     4,     5,     6,     7,     8,
       3,     4,     5,     6,     7,     8,    42,    16,    17,    18,
      19,    20,    42,    16,    17,    18,    19,    20,    -1,    -1,
      -1,     3,     4,     5,     6,     7,     8,     3,     4,     5,
       6,     7,     8,    42,    16,    17,    18,    19,    20,    42,
      16,    17,    18,    19,    20,    -1,    -1,    -1,     3,     4,
       5,     6,     7,     8,     3,     4,     5,     6,     7,     8,
      42,    16,    17,    18,    19,    20,    42,    16,    17,    18,
      19,    20,     4,    -1,    -1,    -1,    -1,    -1,     4,    -1,
      -1,     3,     4,     5,     6,     7,     8,    42,    -1,    21,
      -1,    -1,    -1,    42,    16,    21,    18,    19,    20,    -1,
      -1,    -1,    -1,    -1,    36,    -1,    38,    39,    40,    -1,
      36,    43,    38,    39,    40,    -1,    -1,    43,     3,     4,
       5,     6,     7,     8,     3,     4,     5,     6,     7,     8,
      15,    16,    17,    18,    19,    20,    -1,    16,    17,    18,
      19,    20,    -1,    -1,     3,     4,     5,     6,     7,     8,
       3,     4,     5,     6,     7,     8,    41,    16,    17,    18,
      19,    20,    41,    16,    17,    18,    19,    20,    -1,    -1,
       3,     4,     5,     6,     7,     8,     3,     4,     5,     6,
       7,     8,    41,    16,    17,    18,    19,    20,    41,    16,
      17,    18,    19,    20,    -1,    -1,     3,     4,     5,     6,
       7,     8,     3,     4,     5,     6,     7,     8,    41,    16,
      17,    18,    19,    20,    41,    16,    17,    18,    19,    20,
      -1,    -1,     3,     4,     5,     6,     7,     8,     3,     4,
       5,     6,     7,     8,    41,    16,    17,    18,    19,    20,
      41,    16,    17,    18,    19,    20,    -1,    -1,     3,     4,
       5,     6,     7,     8,     3,     4,     5,     6,     7,     8,
      41,    16,    17,    18,    19,    20,    41,    16,    17,    18,
      19,    20,    -1,    -1,     3,     4,     5,     6,     7,     8,
      -1,    -1,    -1,    -1,    -1,    -1,    41,    16,    17,    18,
      19,    20,    41,     4,    -1,    -1,    -1,    -1,    -1,    -1,
      11,    12,    13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      21,    22,    41,    -1,    -1,    26,    27,    28,    29,    30,
      31,    32,    33,    34,     4,    36,    37,    38,    39,    40,
      -1,    11,    12,    13,    -1,    -1,    -1,    -1,     4,    -1,
      -1,    21,    22,    -1,     4,    -1,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    21,    36,    37,    38,    39,
      40,    21,    -1,    -1,    -1,    -1,    -1,    -1,    13,    -1,
      36,    37,    38,    39,    40,    -1,    36,    -1,    38,    39,
      40,    26,    27,    28,    29,    30,    31,    32,    33,    34,
       3,     4,     5,     6,     7,     8,     3,     4,     5,     6,
       7,     8,    -1,    16,    17,    18,    19,    20,    -1,    16,
      -1,    -1,    19,    20
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     4,    11,    12,    13,    21,    22,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    36,    37,    38,    39,
      40,    47,    48,    49,    50,    51,    52,    56,    40,    56,
      48,    40,    40,    56,    40,    40,    40,    40,    40,    40,
      40,    40,    40,    40,    40,    37,    48,    49,    51,    56,
       0,     9,    10,    14,    15,    16,    15,     3,     4,     5,
       6,     7,     8,    15,    16,    17,    18,    19,    20,    56,
      35,    35,    56,    56,    56,    56,    56,    56,    54,    56,
      56,    56,    56,    56,    41,    41,    42,    41,    41,    48,
      48,    12,    40,    43,    44,    55,    56,    57,    56,    56,
      36,    56,    56,    56,    56,    56,    56,    40,    49,    56,
      56,    56,    56,    56,    42,    41,    42,    42,    42,    42,
      42,    42,    42,    42,    42,    42,    42,    41,    42,    49,
      40,    43,    56,    56,    43,    56,    42,    43,    37,    49,
      40,    49,    56,    56,    56,    56,    56,    56,    56,    49,
      56,    56,    56,    56,    56,    41,    35,    41,    45,    56,
      43,    41,    45,    56,    43,    45,    57,    56,    41,    42,
      42,    42,    42,    42,    42,    42,    42,    42,    42,    42,
      42,    41,    14,    41,    41,    45,    41,    45,    56,    41,
      45,    41,    45,    56,    49,    56,    56,    56,    56,    56,
      56,    56,    49,    56,    56,    56,    13,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    53,    41,    45,    41,
      45,    41,    42,    42,    42,    42,    42,    42,    42,    41,
      42,    42,    40,    40,    40,    40,    40,    40,    40,    40,
      40,    40,    49,    49,    56,    56,    56,    56,    56,    56,
      56,    35,    56,    56,    56,    56,    56,    56,    54,    56,
      56,    42,    42,    42,    42,    42,    42,    42,    42,    42,
      41,    42,    42,    42,    42,    42,    42,    42,    41,    42,
      42,    42,    49,    49,    49,    56,    56,    56,    56,    49,
      56,    56,    56,    56,    56,    56,    56,    56,    56,    56,
      41,    41,    42,    42,    42,    42,    42,    42,    42,    42,
      42,    42,    42,    42,    42,    42,    42,    42,    49,    49,
      56,    49,    49,    49,    49,    56,    56,    56,    56,    56,
      56,    56,    56,    56,    41,    42,    42,    42,    42,    41,
      42,    41,    41,    42,    42,    42,    42,    42,    42,    42,
      49,    56,    49,    49,    49,    56,    56,    56,    56,    56,
      56,    56,    41,    42,    41,    41,    41,    41,    42,    42,
      42,    42,    41,    42,    56,    56,    56,    56,    56,    56,
      42,    41,    42,    41,    41,    41,    49,    56,    42,    42,
      49,    56,    41,    42,    56,    41
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *bottom, yytype_int16 *top)
#else
static void
yy_stack_print (bottom, top)
    yytype_int16 *bottom;
    yytype_int16 *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      fprintf (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      fprintf (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The look-ahead symbol.  */
int yychar;

/* The semantic value of the look-ahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  int yystate;
  int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Look-ahead token as an internal (translated) token number.  */
  int yytoken = 0;
#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  yytype_int16 yyssa[YYINITDEPTH];
  yytype_int16 *yyss = yyssa;
  yytype_int16 *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  YYSTYPE *yyvsp;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     look-ahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to look-ahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a look-ahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid look-ahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the look-ahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 4:
#line 108 "DssParser.y"
    { dssBuilder.negateDss(); }
    break;

  case 5:
#line 109 "DssParser.y"
    { dssBuilder.andDss(); }
    break;

  case 6:
#line 110 "DssParser.y"
    { dssBuilder.orDss(); }
    break;

  case 7:
#line 111 "DssParser.y"
    { dssBuilder.newDss(); }
    break;

  case 8:
#line 114 "DssParser.y"
    { (yyval.yAxisName) = (yyvsp[(1) - (1)].yAxisName); }
    break;

  case 9:
#line 115 "DssParser.y"
    { (yyval.yAxisName) = (yyvsp[(2) - (3)].yAxisName); }
    break;

  case 11:
#line 120 "DssParser.y"
    { if(yyFilteredTable){
                                    const Column *ctemp = yyFilteredTable->column(*(yyvsp[(1) - (3)].yAxisName));
                                    dssBuilder.currentComponent()->
                                            addRangeFilter(ctemp, *(yyvsp[(3) - (3)].yRangeList));
                                  }else{
                                    dssBuilder.currentComponent()->
                                            addRangeFilter(*(yyvsp[(1) - (3)].yAxisName), *(yyvsp[(3) - (3)].yRangeList));
                                  }
                                  delete (yyvsp[(1) - (3)].yAxisName);
                                  delete (yyvsp[(3) - (3)].yRangeList); 
                                }
    break;

  case 12:
#line 132 "DssParser.y"
    { if( ((yyvsp[(2) - (3)].yRelOp) != EqOpT && (yyvsp[(2) - (3)].yRelOp) != NeOpT) || (yyvsp[(3) - (3)].yNumber) != 0 ){
				    selerrstr<<"Bit mask filter must be tested against \"== 0\" "
					     <<" or \"!= 0\"."
					     <<selerror("BitMaskTesting");
  				    SELTHROW(DssBuilder::MiscException);
				  }
				  if((yyvsp[(2) - (3)].yRelOp)==NeOpT) !(*(yyvsp[(1) - (3)].yDSfilter));
                                }
    break;

  case 13:
#line 141 "DssParser.y"
    { if(yyFilteredTable){
                                    const Column *ctemp = yyFilteredTable->column(*(yyvsp[(1) - (6)].yAxisName));
                                    dssBuilder.currentComponent()->
                                           addBlockFilter(ctemp, *(yyvsp[(5) - (6)].yBlockSpec));
                                  }else{
                                    dssBuilder.currentComponent()->
                                            addBlockFilter(*(yyvsp[(1) - (6)].yAxisName), *(yyvsp[(5) - (6)].yBlockSpec));
                                  }
                                  delete (yyvsp[(1) - (6)].yAxisName);
                                  delete (yyvsp[(5) - (6)].yBlockSpec);
                                }
    break;

  case 14:
#line 153 "DssParser.y"
    { if(yyFilteredTable){
                                    const Column *ctemp = yyFilteredTable->column(*(yyvsp[(5) - (6)].yAxisName));
                                    dssBuilder.currentComponent()->
                                            addBlockFilter(ctemp, *(yyvsp[(3) - (6)].yBlockSpec));
                                  }else{
                                    dssBuilder.currentComponent()->
                                            addBlockFilter(*(yyvsp[(5) - (6)].yAxisName), *(yyvsp[(3) - (6)].yBlockSpec));
                                  }
                                  delete (yyvsp[(3) - (6)].yBlockSpec);
                                  delete (yyvsp[(5) - (6)].yAxisName);
                                }
    break;

  case 15:
#line 165 "DssParser.y"
    { DSS::DSfilterComp fcomp(2);
                                  fcomp[0] = *(yyvsp[(2) - (10)].yAxisName);
                                  fcomp[1] = *(yyvsp[(4) - (10)].yAxisName);
                                  dssBuilder.currentComponent()->
                                           addBlockFilter(dssBuilder.Axis2dName(fcomp), *(yyvsp[(9) - (10)].yBlockSpec), fcomp);
                                  delete (yyvsp[(2) - (10)].yAxisName);
                                  delete (yyvsp[(4) - (10)].yAxisName);
                                }
    break;

  case 16:
#line 174 "DssParser.y"
    { DSS::DSfilterComp fcomp(2);
                                  dssBuilder.currentComponent()->
                                           addBlockFilter(dssBuilder.Axis2dName(fcomp), *(yyvsp[(3) - (4)].yBlockSpec));
                                }
    break;

  case 17:
#line 179 "DssParser.y"
    { DSS::DSfilterComp fcomp(2);
                                  fcomp[0] = *(yyvsp[(5) - (8)].yAxisName);
                                  fcomp[1] = *(yyvsp[(7) - (8)].yAxisName);
                                  dssBuilder.currentComponent()->
                                           addBlockFilter(dssBuilder.Axis2dName(fcomp), *(yyvsp[(3) - (8)].yBlockSpec), fcomp);
                                  delete (yyvsp[(5) - (8)].yAxisName);
                                  delete (yyvsp[(7) - (8)].yAxisName);
                                }
    break;

  case 18:
#line 188 "DssParser.y"
    { if( (yyvsp[(11) - (14)].yNumber) != 0 || (yyvsp[(13) - (14)].yNumber) != 0 ){
				    selerrstr<<"Mask filter must have zero offset in the data subspace."
					     <<selerror("MaskSpecOffset");
  				    SELTHROW(DssBuilder::MiscException);
				  }
				  DSS::DSfilterComp fcomp(2);
                                  fcomp[0] = *(yyvsp[(2) - (14)].yAxisName);
                                  fcomp[1] = *(yyvsp[(4) - (14)].yAxisName);
                                  dssBuilder.currentComponent()->
                                           addBlockFilter(dssBuilder.Axis2dName(fcomp), *(yyvsp[(9) - (14)].yBlockSpec), fcomp);
                                  delete (yyvsp[(2) - (14)].yAxisName);
                                  delete (yyvsp[(4) - (14)].yAxisName);
                                }
    break;

  case 19:
#line 202 "DssParser.y"
    { if( (yyvsp[(5) - (12)].yNumber) != 0 || (yyvsp[(7) - (12)].yNumber) != 0 ){
				    selerrstr<<"Mask filter must have zero offset in the data subspace."
					     <<selerror("MaskSpecOffset");
  				    SELTHROW(DssBuilder::MiscException);
				  }
				  DSS::DSfilterComp fcomp(2);
                                  fcomp[0] = *(yyvsp[(9) - (12)].yAxisName);
                                  fcomp[1] = *(yyvsp[(11) - (12)].yAxisName);
                                  dssBuilder.currentComponent()->
                                           addBlockFilter(dssBuilder.Axis2dName(fcomp), *(yyvsp[(3) - (12)].yBlockSpec), fcomp);
                                  delete (yyvsp[(9) - (12)].yAxisName);
                                  delete (yyvsp[(11) - (12)].yAxisName);
                                }
    break;

  case 20:
#line 216 "DssParser.y"
    { DRangeList rlist;
				  switch ((yyvsp[(2) - (3)].yRelOp)) {
				  case LtOpT:{
				    DRange range(-DBL_MAX, (yyvsp[(3) - (3)].yNumber), Unbounded, Open);
				    rlist.push_back(range);
				    break; }
				  case LeOpT:{
				    DRange range(-DBL_MAX, (yyvsp[(3) - (3)].yNumber), Unbounded, Closed);
				    rlist.push_back(range);
				    break; }
				  case GtOpT:{
				    DRange range((yyvsp[(3) - (3)].yNumber), DBL_MAX, Open, Unbounded);
				    rlist.push_back(range);
				    break; }
				  case GeOpT:{
				    DRange range((yyvsp[(3) - (3)].yNumber), DBL_MAX, Closed, Unbounded);
				    rlist.push_back(range);
				    break; }
				  case EqOpT:{
				    DRange range((yyvsp[(3) - (3)].yNumber), (yyvsp[(3) - (3)].yNumber), Closed, Closed);
				    rlist.push_back(range);
				    break; }
				  case NeOpT:{
				    DRange range1((yyvsp[(3) - (3)].yNumber), DBL_MAX, Open, Unbounded);
				    DRange range2(-DBL_MAX, (yyvsp[(3) - (3)].yNumber), Unbounded, Open);
				    rlist.push_back(range1);
				    rlist.push_back(range2);
				    break; }
				  }

				  if(yyFilteredTable){
				    const Column *ctemp = yyFilteredTable->column(*(yyvsp[(1) - (3)].yAxisName));
				    dssBuilder.currentComponent()->
				                   addRangeFilter(ctemp, rlist);
				  }else{
				    dssBuilder.currentComponent()->
				                   addRangeFilter(*(yyvsp[(1) - (3)].yAxisName), rlist);
				  }

                                  delete (yyvsp[(1) - (3)].yAxisName);
				}
    break;

  case 21:
#line 258 "DssParser.y"
    { DRangeList rlist;
				  switch ((yyvsp[(2) - (3)].yRelOp)) {
				  case GtOpT:{
				    DRange range(-DBL_MAX, (yyvsp[(1) - (3)].yNumber), Unbounded, Open);
				    rlist.push_back(range);
				    break; }
				  case GeOpT:{
				    DRange range(-DBL_MAX, (yyvsp[(1) - (3)].yNumber), Unbounded, Closed);
				    rlist.push_back(range);
				    break; }
				  case LtOpT:{
				    DRange range((yyvsp[(1) - (3)].yNumber), DBL_MAX, Open, Unbounded);
				    rlist.push_back(range);
				    break; }
				  case LeOpT:{
				    DRange range((yyvsp[(1) - (3)].yNumber), DBL_MAX, Closed, Unbounded);
				    rlist.push_back(range);
				    break; }
				  case EqOpT:{
				    DRange range((yyvsp[(1) - (3)].yNumber), (yyvsp[(1) - (3)].yNumber), Closed, Closed);
				    rlist.push_back(range);
				    break; }
                                  case NeOpT:{
				    DRange range1((yyvsp[(1) - (3)].yNumber), DBL_MAX, Open, Unbounded);
				    DRange range2(-DBL_MAX, (yyvsp[(1) - (3)].yNumber), Unbounded, Open);
				    rlist.push_back(range1);
				    rlist.push_back(range2);
				    break; }
				  }

				  if(yyFilteredTable){
				    const Column *ctemp = yyFilteredTable->column(*(yyvsp[(3) - (3)].yAxisName));
				    dssBuilder.currentComponent()->
				                   addRangeFilter(ctemp, rlist);
				  }else{
				    dssBuilder.currentComponent()->
				                   addRangeFilter(*(yyvsp[(3) - (3)].yAxisName), rlist);
				  }
                                  delete (yyvsp[(3) - (3)].yAxisName);
				}
    break;

  case 22:
#line 299 "DssParser.y"
    { GeoRegion r;
                                  r.push_back(
                                        *dssBuilder.currentRegionComponent());
                                  DSS::DSfilterComp fc(2);
                                  fc[0] = dssBuilder.xAxisName();
                                  fc[1] = dssBuilder.yAxisName();
                                  dssBuilder.currentComponent()->
                                          addRegionFilter(dssBuilder.Axis2dName(fc), r, fc);
                                }
    break;

  case 23:
#line 311 "DssParser.y"
    { DSfilter *dsbit=0;
				  vector<uint32_t> onBits;
				  vector<uint32_t> offBits;
				  onBits.push_back(0);
				  offBits.push_back(UINT((yyvsp[(3) - (3)].yNumber)));
				  if(yyFilteredTable){
                                    const Column *ctemp = yyFilteredTable->column(*(yyvsp[(1) - (3)].yAxisName));
                                    dsbit = dssBuilder.currentComponent()->
				               addBitFilter(ctemp, onBits, offBits);
                                  }else{
                                    dsbit = dssBuilder.currentComponent()->
                                               addBitFilter(*(yyvsp[(1) - (3)].yAxisName), onBits, offBits);
                                  }
                                  delete (yyvsp[(1) - (3)].yAxisName);
				  (yyval.yDSfilter) = dsbit;
				}
    break;

  case 24:
#line 328 "DssParser.y"
    {(yyval.yDSfilter)=(yyvsp[(2) - (3)].yDSfilter);}
    break;

  case 26:
#line 332 "DssParser.y"
    { dssBuilder.regionAxes(*(yyvsp[(2) - (7)].yAxisName), *(yyvsp[(4) - (7)].yAxisName));
                                  delete (yyvsp[(2) - (7)].yAxisName); delete (yyvsp[(4) - (7)].yAxisName); }
    break;

  case 27:
#line 335 "DssParser.y"
    { dssBuilder.addRegion(new FCircle(FPoint((yyvsp[(3) - (12)].yNumber), (yyvsp[(5) - (12)].yNumber)), (yyvsp[(7) - (12)].yNumber)));
                    dssBuilder.regionAxes(*(yyvsp[(9) - (12)].yAxisName), *(yyvsp[(11) - (12)].yAxisName));
                    delete (yyvsp[(9) - (12)].yAxisName); delete (yyvsp[(11) - (12)].yAxisName);
		  }
    break;

  case 28:
#line 340 "DssParser.y"
    { dssBuilder.addRegion(new FAnnulus(FPoint((yyvsp[(3) - (14)].yNumber), (yyvsp[(5) - (14)].yNumber)), (yyvsp[(7) - (14)].yNumber), (yyvsp[(9) - (14)].yNumber))); 
                    dssBuilder.regionAxes(*(yyvsp[(11) - (14)].yAxisName), *(yyvsp[(13) - (14)].yAxisName));
                    delete (yyvsp[(11) - (14)].yAxisName); delete (yyvsp[(13) - (14)].yAxisName);
		  }
    break;

  case 29:
#line 345 "DssParser.y"
    { dssBuilder.addRegion(new FEllipse(FPoint((yyvsp[(3) - (16)].yNumber), (yyvsp[(5) - (16)].yNumber)), (yyvsp[(7) - (16)].yNumber), (yyvsp[(9) - (16)].yNumber), (yyvsp[(11) - (16)].yNumber)));
                    dssBuilder.regionAxes(*(yyvsp[(13) - (16)].yAxisName), *(yyvsp[(15) - (16)].yAxisName));
                    delete (yyvsp[(13) - (16)].yAxisName); delete (yyvsp[(15) - (16)].yAxisName);
		  }
    break;

  case 30:
#line 350 "DssParser.y"
    { dssBuilder.addRegion(new FElliptAnnulus(FPoint((yyvsp[(3) - (22)].yNumber), (yyvsp[(5) - (22)].yNumber)), (yyvsp[(7) - (22)].yNumber), (yyvsp[(9) - (22)].yNumber), (yyvsp[(11) - (22)].yNumber), (yyvsp[(13) - (22)].yNumber), (yyvsp[(15) - (22)].yNumber), (yyvsp[(17) - (22)].yNumber))); 
                    dssBuilder.regionAxes(*(yyvsp[(19) - (22)].yAxisName), *(yyvsp[(21) - (22)].yAxisName));
                    delete (yyvsp[(19) - (22)].yAxisName); delete (yyvsp[(21) - (22)].yAxisName);
		  }
    break;

  case 31:
#line 355 "DssParser.y"
    { dssBuilder.addRegion(new FRotBox(FPoint((yyvsp[(3) - (16)].yNumber), (yyvsp[(5) - (16)].yNumber)), 2*(yyvsp[(7) - (16)].yNumber), 2*(yyvsp[(9) - (16)].yNumber), (yyvsp[(11) - (16)].yNumber)));
                    dssBuilder.regionAxes(*(yyvsp[(13) - (16)].yAxisName), *(yyvsp[(15) - (16)].yAxisName));
                    delete (yyvsp[(13) - (16)].yAxisName); delete (yyvsp[(15) - (16)].yAxisName);
		  }
    break;

  case 32:
#line 360 "DssParser.y"
    { dssBuilder.addRegion(new FRotRectangle(FPoint((yyvsp[(3) - (16)].yNumber), (yyvsp[(5) - (16)].yNumber)), FPoint((yyvsp[(7) - (16)].yNumber), (yyvsp[(9) - (16)].yNumber)), (yyvsp[(11) - (16)].yNumber)));
                    dssBuilder.regionAxes(*(yyvsp[(13) - (16)].yAxisName), *(yyvsp[(15) - (16)].yAxisName));
                    delete (yyvsp[(13) - (16)].yAxisName); delete (yyvsp[(15) - (16)].yAxisName);
		  }
    break;

  case 33:
#line 365 "DssParser.y"
    { dssBuilder.addRegion(new FRotRhombus(FPoint((yyvsp[(3) - (16)].yNumber), (yyvsp[(5) - (16)].yNumber)), (yyvsp[(7) - (16)].yNumber), (yyvsp[(9) - (16)].yNumber), (yyvsp[(11) - (16)].yNumber)));
                    dssBuilder.regionAxes(*(yyvsp[(13) - (16)].yAxisName), *(yyvsp[(15) - (16)].yAxisName));
                    delete (yyvsp[(13) - (16)].yAxisName); delete (yyvsp[(15) - (16)].yAxisName);
		  }
    break;

  case 34:
#line 370 "DssParser.y"
    { dssBuilder.addRegion(new FSector(FPoint((yyvsp[(3) - (14)].yNumber), (yyvsp[(5) - (14)].yNumber)), (yyvsp[(7) - (14)].yNumber), (yyvsp[(9) - (14)].yNumber))); 
                    dssBuilder.regionAxes(*(yyvsp[(11) - (14)].yAxisName), *(yyvsp[(13) - (14)].yAxisName));
                    delete (yyvsp[(11) - (14)].yAxisName); delete (yyvsp[(13) - (14)].yAxisName);
		  }
    break;

  case 35:
#line 375 "DssParser.y"
    { dssBuilder.addRegion(new FPolygon((yyvsp[(3) - (8)].yPointList)[0], (yyvsp[(3) - (8)].yPointList)[1], (yyvsp[(3) - (8)].yPointList)[0].size()));
                    delete [] (yyvsp[(3) - (8)].yPointList); 
                    dssBuilder.regionAxes(*(yyvsp[(5) - (8)].yAxisName), *(yyvsp[(7) - (8)].yAxisName));
                    delete (yyvsp[(5) - (8)].yAxisName); delete (yyvsp[(7) - (8)].yAxisName);
		  }
    break;

  case 36:
#line 383 "DssParser.y"
    { dssBuilder.addRegion(new FCircle(FPoint((yyvsp[(3) - (8)].yNumber), (yyvsp[(5) - (8)].yNumber)), (yyvsp[(7) - (8)].yNumber))); 
	  }
    break;

  case 37:
#line 386 "DssParser.y"
    { dssBuilder.addRegion(new FAnnulus(FPoint((yyvsp[(3) - (10)].yNumber), (yyvsp[(5) - (10)].yNumber)), (yyvsp[(7) - (10)].yNumber), (yyvsp[(9) - (10)].yNumber))); 
	  }
    break;

  case 38:
#line 389 "DssParser.y"
    { dssBuilder.addRegion(new FEllipse(FPoint((yyvsp[(3) - (12)].yNumber), (yyvsp[(5) - (12)].yNumber)), (yyvsp[(7) - (12)].yNumber), (yyvsp[(9) - (12)].yNumber), (yyvsp[(11) - (12)].yNumber)));
	  }
    break;

  case 39:
#line 392 "DssParser.y"
    { dssBuilder.addRegion(new FElliptAnnulus(FPoint((yyvsp[(3) - (18)].yNumber), (yyvsp[(5) - (18)].yNumber)), (yyvsp[(7) - (18)].yNumber), (yyvsp[(9) - (18)].yNumber), (yyvsp[(11) - (18)].yNumber), (yyvsp[(13) - (18)].yNumber), (yyvsp[(15) - (18)].yNumber), (yyvsp[(17) - (18)].yNumber))); 
	  }
    break;

  case 40:
#line 395 "DssParser.y"
    { dssBuilder.addRegion(new FRotBox(FPoint((yyvsp[(3) - (12)].yNumber), (yyvsp[(5) - (12)].yNumber)), 2*(yyvsp[(7) - (12)].yNumber), 2*(yyvsp[(9) - (12)].yNumber), (yyvsp[(11) - (12)].yNumber)));
	  }
    break;

  case 41:
#line 398 "DssParser.y"
    { dssBuilder.addRegion(new FRotRectangle(FPoint((yyvsp[(3) - (12)].yNumber), (yyvsp[(5) - (12)].yNumber)), FPoint((yyvsp[(7) - (12)].yNumber), (yyvsp[(9) - (12)].yNumber)), (yyvsp[(11) - (12)].yNumber)));
	  }
    break;

  case 42:
#line 401 "DssParser.y"
    { dssBuilder.addRegion(new FRotRhombus(FPoint((yyvsp[(3) - (12)].yNumber), (yyvsp[(5) - (12)].yNumber)), (yyvsp[(7) - (12)].yNumber), (yyvsp[(9) - (12)].yNumber), (yyvsp[(11) - (12)].yNumber)));
	  }
    break;

  case 43:
#line 404 "DssParser.y"
    { dssBuilder.addRegion(new FSector(FPoint((yyvsp[(3) - (10)].yNumber), (yyvsp[(5) - (10)].yNumber)), (yyvsp[(7) - (10)].yNumber), (yyvsp[(9) - (10)].yNumber))); 
	  }
    break;

  case 44:
#line 407 "DssParser.y"
    { dssBuilder.addRegion(new FPolygon((yyvsp[(3) - (4)].yPointList)[0], (yyvsp[(3) - (4)].yPointList)[1], (yyvsp[(3) - (4)].yPointList)[0].size()));
            delete [] (yyvsp[(3) - (4)].yPointList); 
	  }
    break;

  case 45:
#line 413 "DssParser.y"
    { (yyvsp[(1) - (5)].yPointList)[0].push_back((yyvsp[(3) - (5)].yNumber));
                                  (yyvsp[(1) - (5)].yPointList)[1].push_back((yyvsp[(5) - (5)].yNumber));
                                  (yyval.yPointList) = (yyvsp[(1) - (5)].yPointList); }
    break;

  case 46:
#line 417 "DssParser.y"
    { std::vector<float> x; x.push_back((yyvsp[(1) - (3)].yNumber));
                                  std::vector<float> y; y.push_back((yyvsp[(3) - (3)].yNumber));
                                  std::vector<float> *v =
                                        new std::vector<float>[2];
                                  v[0] = x; v[1] = y;
                                  (yyval.yPointList) = v; }
    break;

  case 47:
#line 426 "DssParser.y"
    { (yyvsp[(1) - (3)].yRangeList)->push_back(*(yyvsp[(3) - (3)].yRange));
                                  delete (yyvsp[(3) - (3)].yRange);
                                  (yyval.yRangeList) = (yyvsp[(1) - (3)].yRangeList);
                                }
    break;

  case 48:
#line 430 "DssParser.y"
    { (yyval.yRangeList) = new DRangeList;
                                  (yyval.yRangeList)->push_back(*(yyvsp[(1) - (1)].yRange));
                                  delete (yyvsp[(1) - (1)].yRange);
                                }
    break;

  case 49:
#line 436 "DssParser.y"
    { (yyval.yNumber) = (yyvsp[(1) - (3)].yNumber) + (yyvsp[(3) - (3)].yNumber); }
    break;

  case 50:
#line 437 "DssParser.y"
    { (yyval.yNumber) = (yyvsp[(1) - (3)].yNumber) - (yyvsp[(3) - (3)].yNumber); }
    break;

  case 51:
#line 438 "DssParser.y"
    { (yyval.yNumber) = (yyvsp[(1) - (3)].yNumber) * (yyvsp[(3) - (3)].yNumber); }
    break;

  case 52:
#line 439 "DssParser.y"
    { if ((yyvsp[(3) - (3)].yNumber) == 0.) {
                                      selerrstr<<"Division by 0 in `/' operator."
                                           <<selerror("ArithmeticException");
                                    SELTHROW(DssBuilder::ArithmeticException);
                                  }
                                  (yyval.yNumber) = (yyvsp[(1) - (3)].yNumber) / (yyvsp[(3) - (3)].yNumber);
                                }
    break;

  case 53:
#line 446 "DssParser.y"
    { if ((yyvsp[(3) - (3)].yNumber) == 0.) {
                                      selerrstr<<"Division by 0 in `modulo' operator."
                                           <<selerror("ArithmeticException");
                                    SELTHROW(DssBuilder::ArithmeticException);
                                  }
                                  (yyval.yNumber) = fmod((yyvsp[(1) - (3)].yNumber), (yyvsp[(3) - (3)].yNumber));
                                }
    break;

  case 54:
#line 453 "DssParser.y"
    { double dum;
                                  if ((yyvsp[(1) - (3)].yNumber) < 0. && modf((yyvsp[(3) - (3)].yNumber), &dum) != 0.) {
                                      selerrstr<<"Cannot raise "<<(yyvsp[(1) - (3)].yNumber)<<" to the power "<<(yyvsp[(3) - (3)].yNumber)<<" ."
                                           <<selerror("ArithmeticException");
                                    SELTHROW(DssBuilder::ArithmeticException);
                                  }
                                  (yyval.yNumber) = pow((yyvsp[(1) - (3)].yNumber), (yyvsp[(3) - (3)].yNumber));
                                }
    break;

  case 55:
#line 461 "DssParser.y"
    { (yyval.yNumber) = DBL(UNT((yyvsp[(1) - (3)].yNumber)) & UNT((yyvsp[(3) - (3)].yNumber))); }
    break;

  case 56:
#line 462 "DssParser.y"
    { (yyval.yNumber) = DBL(UNT((yyvsp[(1) - (3)].yNumber)) | UNT((yyvsp[(3) - (3)].yNumber))); }
    break;

  case 57:
#line 463 "DssParser.y"
    { (yyval.yNumber) = DBL(UNT((yyvsp[(1) - (3)].yNumber)) ^ UNT((yyvsp[(3) - (3)].yNumber))); }
    break;

  case 58:
#line 464 "DssParser.y"
    { (yyval.yNumber) = DBL(UNT((yyvsp[(1) - (3)].yNumber)) << UNT((yyvsp[(3) - (3)].yNumber))); }
    break;

  case 59:
#line 465 "DssParser.y"
    { (yyval.yNumber) = DBL(UNT((yyvsp[(1) - (3)].yNumber)) >> UNT((yyvsp[(3) - (3)].yNumber))); }
    break;

  case 60:
#line 466 "DssParser.y"
    { (yyval.yNumber) = DBL(~UNT((yyvsp[(2) - (2)].yNumber))); }
    break;

  case 61:
#line 467 "DssParser.y"
    { (yyval.yNumber) = (*(yyvsp[(1) - (4)].yFunc1))((yyvsp[(3) - (4)].yNumber)); }
    break;

  case 62:
#line 469 "DssParser.y"
    { (yyval.yNumber) = (*(yyvsp[(1) - (6)].yFunc2))((yyvsp[(3) - (6)].yNumber), (yyvsp[(5) - (6)].yNumber)); }
    break;

  case 63:
#line 470 "DssParser.y"
    { (yyval.yNumber) = -(yyvsp[(2) - (2)].yNumber); }
    break;

  case 64:
#line 471 "DssParser.y"
    { (yyval.yNumber) = (yyvsp[(2) - (3)].yNumber); }
    break;

  case 66:
#line 475 "DssParser.y"
    { (yyval.yRange) = new DRange(-DBL_MAX, DBL_MAX,
                                                          Unbounded, Unbounded); }
    break;

  case 67:
#line 477 "DssParser.y"
    { (yyval.yRange) = new DRange(-DBL_MAX, DBL_MAX,
                                                          Unbounded, Unbounded); }
    break;

  case 68:
#line 479 "DssParser.y"
    { (yyval.yRange) = new DRange(-DBL_MAX, DBL_MAX,
                                                          Unbounded, Unbounded); }
    break;

  case 69:
#line 481 "DssParser.y"
    { (yyval.yRange) = new DRange(-DBL_MAX, DBL_MAX,
                                                          Unbounded, Unbounded); }
    break;

  case 70:
#line 483 "DssParser.y"
    { (yyval.yRange) = new DRange(-DBL_MAX, DBL_MAX,
                                                          Unbounded, Unbounded); }
    break;

  case 71:
#line 485 "DssParser.y"
    { (yyval.yRange) = new DRange((yyvsp[(1) - (1)].yNumber), (yyvsp[(1) - (1)].yNumber)); }
    break;

  case 72:
#line 486 "DssParser.y"
    { (yyval.yRange) = new DRange((yyvsp[(2) - (3)].yNumber), (yyvsp[(2) - (3)].yNumber)); }
    break;

  case 73:
#line 487 "DssParser.y"
    { (yyval.yRange) = new DRange((yyvsp[(1) - (2)].yNumber), DBL_MAX,
                                                          Closed, Unbounded); }
    break;

  case 74:
#line 489 "DssParser.y"
    { (yyval.yRange) = new DRange((yyvsp[(2) - (4)].yNumber), DBL_MAX,
                                                          Closed, Unbounded); }
    break;

  case 75:
#line 491 "DssParser.y"
    { (yyval.yRange) = new DRange((yyvsp[(2) - (4)].yNumber), DBL_MAX,
                                                          Closed, Unbounded); }
    break;

  case 76:
#line 493 "DssParser.y"
    { (yyval.yRange) = new DRange((yyvsp[(2) - (4)].yNumber), DBL_MAX,
                                                          Open, Unbounded); }
    break;

  case 77:
#line 495 "DssParser.y"
    { (yyval.yRange) = new DRange((yyvsp[(2) - (4)].yNumber), DBL_MAX,
                                                          Open, Unbounded); }
    break;

  case 78:
#line 497 "DssParser.y"
    { (yyval.yRange) = new DRange(-DBL_MAX, (yyvsp[(2) - (2)].yNumber),
                                                          Unbounded, Closed); }
    break;

  case 79:
#line 499 "DssParser.y"
    { (yyval.yRange) = new DRange(-DBL_MAX, (yyvsp[(3) - (4)].yNumber),
                                                          Unbounded, Closed); }
    break;

  case 80:
#line 501 "DssParser.y"
    { (yyval.yRange) = new DRange(-DBL_MAX, (yyvsp[(3) - (4)].yNumber),
                                                          Unbounded, Open); }
    break;

  case 81:
#line 503 "DssParser.y"
    { (yyval.yRange) = new DRange(-DBL_MAX, (yyvsp[(3) - (4)].yNumber),
                                                          Unbounded, Closed); }
    break;

  case 82:
#line 505 "DssParser.y"
    { (yyval.yRange) = new DRange(-DBL_MAX, (yyvsp[(3) - (4)].yNumber),
                                                          Unbounded, Open); }
    break;

  case 83:
#line 507 "DssParser.y"
    { (yyval.yRange) = new DRange((yyvsp[(1) - (3)].yNumber), (yyvsp[(3) - (3)].yNumber)); }
    break;

  case 84:
#line 508 "DssParser.y"
    { (yyval.yRange) = new DRange((yyvsp[(2) - (5)].yNumber), (yyvsp[(4) - (5)].yNumber)); }
    break;

  case 85:
#line 509 "DssParser.y"
    { (yyval.yRange) = new DRange((yyvsp[(2) - (5)].yNumber), (yyvsp[(4) - (5)].yNumber),
                                                          Open, Closed); }
    break;

  case 86:
#line 511 "DssParser.y"
    { (yyval.yRange) = new DRange((yyvsp[(2) - (5)].yNumber), (yyvsp[(4) - (5)].yNumber),
                                                          Closed, Open); }
    break;

  case 87:
#line 513 "DssParser.y"
    { (yyval.yRange) = new DRange((yyvsp[(2) - (5)].yNumber), (yyvsp[(4) - (5)].yNumber),
                                                          Open, Open); }
    break;


/* Line 1267 of yacc.c.  */
#line 2703 "DssParser.cc"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse look-ahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEOF && yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


#line 516 "DssParser.y"


}

